/*
 * $Id$
 *
 * (C) 2003-2006 Gabest
 * (C) 2006-2010 see AUTHORS
 *
 * This file is part of mplayerc.
 *
 * Mplayerc is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Mplayerc is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#if !defined(AFX_STDAFX_H__C76533D6_6242_4BEB_8FD3_C6BE58F07224__INCLUDED_)
#define AFX_STDAFX_H__C76533D6_6242_4BEB_8FD3_C6BE58F07224__INCLUDED_

#pragma once

#include "../../DSUtil/SharedInclude.h"

#define HITTEST_RET LRESULT
#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers

#include <afxwin.h>			// MFC core and standard components
#include <afxext.h>			// MFC extensions
#include <afxdisp.h>		// MFC Automation classes
#include <afxdtctl.h>		// MFC support for Internet Explorer 4 Common Controls
#ifndef _AFX_NO_AFXCMN_SUPPORT
#include <afxcmn.h>			// MFC support for Windows Common Controls
#endif // _AFX_NO_AFXCMN_SUPPORT
#include <afxdlgs.h>

#define ResStr(id) CString(MAKEINTRESOURCE(id))

#include <afxdisp.h>
#include <afxole.h>
#include <Shlwapi.h>
#include <atlcoll.h>
#include <atlpath.h>
#include "../../thirdparty/zlib/zlib.h"
#include <streams.h>
#include <dvdmedia.h>
#include <mpconfig.h>

#ifndef _WIN64
#include <qt/qt.h>
#endif

#include "../../CmdUI/CmdUI.h"
#include "../../thirdparty/ui/ResizableLib/ResizableDialog.h"
#include "../../thirdparty/ui/ResizableLib/ResizablePage.h"
#include "../../thirdparty/ui/ResizableLib/ResizableSheet.h"
#include "../../thirdparty/ui/sizecbar/sizecbar.h"
#include "../../thirdparty/ui/sizecbar/scbarcf.h"
#include "../../thirdparty/ui/sizecbar/scbarg.h"
#include "../../thirdparty/ui/TreePropSheet/TreePropSheet.h"
#include "../../DSUtil/DSUtil.h"

#include <gdiplus.h>

template <class T = CString, class S = CString>
class CAtlStringMap : public CAtlMap<S, T, CStringElementTraits<S> > {};

#define CheckAndLog(x, msg)		hr = ##x; if (FAILED (hr)) { TRACE(msg" : 0x%08x\n", hr); return hr; }
#define CheckNoLog(x)			hr = ##x; if (FAILED (hr)) { return hr; }

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__C76533D6_6242_4BEB_8FD3_C6BE58F07224__INCLUDED_)
